 /***********************************************************************
 *                                                                      *
 * lcd.h                                                                *
 * This is lcd driver header file for SVT17702.                         *
 * History:  2008/04/01  Start.                                         *
 *                                                                      *
 ***********************************************************************/

#ifndef LCD_H_
#define LCD_H_

extern void initLcdPower(unsigned char, unsigned char);
extern void stopLcdClk(void);
extern void startLcdClk(unsigned char, unsigned char);
extern void setLcdContrast(unsigned char);
extern void lcdOn(void);
extern void lcdOff(void);
extern void lcdAllOn(void);
extern void lcdAllOff(void);
extern void initLcd(unsigned char, unsigned char);
extern unsigned char reverseLcdArea(void);
extern unsigned char reverseLcdSeg(void);
extern unsigned char reverseLcdCom(void);
extern unsigned char reverseLcdBW(void);
extern void resetLcdIF(void);
extern void startLcdInt(void);
extern void stopLcdInt(void);
extern void initLcdInt(unsigned char intLevel);

#define LCD_PWR_BOOSTER_OFF		0		// power voltage booster. off
#define LCD_PWR_BOOSTER_ON		1		// power voltage booster. on

#define LCD_HEAVY_PROTECT_OFF	0		// LCD heavy load protection mode. off
#define LCD_HEAVY_PROTECT_ON	1		// LCD heavy load protection mode. on

#define LCD_CLK_SELECT_OSC1		1		// LCD clock source. OSC1
#define LCD_CLK_SELECT_HSCLK	0		// LCD clock source. HSCLK

#define LCD_CLK_DIV_32			0x0		// LCD clock division ratio. OSC3/1/32
#define LCD_CLK_DIV_64			0x1		// LCD clock division ratio. OSC3/1/64
#define LCD_CLK_DIV_128			0x2		// LCD clock division ratio. OSC3/1/128
#define LCD_CLK_DIV_256			0x3		// LCD clock division ratio. OSC3/1/256
#define LCD_CLK_DIV_512			0x4		// LCD clock division ratio. OSC3/1/512

#define LCD_DUTY_16				1		// LCD duty. 1/16
#define LCD_DUTY_32				2		// LCD duty. 1/32

#define LCD_CONTRAST_LV_0		0x0		// LCD contrast. LV.0 (the lightest)
#define LCD_CONTRAST_LV_1		0x1		// LCD contrast. LV.1
#define LCD_CONTRAST_LV_2		0x2		// LCD contrast. LV.2
#define LCD_CONTRAST_LV_3		0x3		// LCD contrast. LV.3
#define LCD_CONTRAST_LV_4		0x4		// LCD contrast. LV.4
#define LCD_CONTRAST_LV_5		0x5		// LCD contrast. LV.5
#define LCD_CONTRAST_LV_6		0x6		// LCD contrast. LV.6
#define LCD_CONTRAST_LV_7		0x7		// LCD contrast. LV.7
#define LCD_CONTRAST_LV_8		0x8		// LCD contrast. LV.8
#define LCD_CONTRAST_LV_9		0x9		// LCD contrast. LV.9
#define LCD_CONTRAST_LV_10		0xa		// LCD contrast. LV.10
#define LCD_CONTRAST_LV_11		0xb		// LCD contrast. LV.11
#define LCD_CONTRAST_LV_12		0xc		// LCD contrast. LV.12
#define LCD_CONTRAST_LV_13		0xd		// LCD contrast. LV.13
#define LCD_CONTRAST_LV_14		0xe		// LCD contrast. LV.14
#define LCD_CONTRAST_LV_15		0xf		// LCD contrast. LV.15 (the darkest)

#define LCD_DUTY_16_AREA0		0		// display memory area when 1/16 duty. Area 0
#define LCD_DUTY_16_AREA1		1		// display memory area when 1/16 duty. Area 1

#define LCD_TERMINAL_ORDER_DEC	0		// segment/common output order. descending
#define LCD_TERMINAL_ORDER_ASC	1		// segment/common output order. ascending

#define LCD_BW_REVERSE			0		// LCD monochrome. reverse
#define LCD_BW_NORMAL			1		// LCD monochrome. normal

#endif /*LCD_H_*/
