 /***********************************************************************
 *                                                                      *
 * osc.h                                                                *
 * This is osc driver header file for SVT17702.                         *
 * History:  2008/03/28  Start.                                         *
 *                                                                      *
 ***********************************************************************/

#ifndef _OSC_H
#define _OSC_H
#include "s1c17702.h"

extern  unsigned char stopOsc1(void);
extern  void startOsc1(void);
extern  unsigned char  stopOsc3(void);
extern  void startOsc3(void);
extern  unsigned char stopIosc(void);
extern  void startIosc(void);
extern  void changeSysClkHsclkTo1(void);
extern  void changeSysClkOsc1ToHsclk(unsigned char selectClk);
extern  void changeSysClkIoscTo3(void);
extern  void changeSysClkOsc3ToIosc(void);
extern  void initFoutH(unsigned char clkDivRate);
extern  void startFoutH(unsigned char selectClk);
extern  void stopFoutH(void);
extern  void initFout1(void);
extern  void startFout1(void);
extern  void stopFout1(void);

#define	IOSC_WAIT_CYCLE_64			0		// IOSC wait 64 cycle
#define	IOSC_WAIT_CYCLE_32			1		// IOSC wait 32 cycle
#define	IOSC_WAIT_CYCLE_16			2		// IOSC wait 16 cycle
#define	IOSC_WAIT_CYCLE_8			3		// IOSC wait 8 cycle
#define	OSC3_WAIT_CYCLE_1024		0		// OSC3 wait 1024 cycle
#define	OSC3_WAIT_CYCLE_512			1		// OSC3 wait 512 cycle
#define	OSC3_WAIT_CYCLE_256			2		// OSC3 wait 256 cycle
#define	OSC3_WAIT_CYCLE_128			3		// OSC3 wait 128 cycle
#define	OSC_STOP_NG					0		// Fail
#define	OSC_STOP_OK					1		// Success
#define	FOUT3_CLK_DIV_RATE_1		0		// FOUT3=OSC3 1/1
#define	FOUT3_CLK_DIV_RATE_2		1		// FOUT3=OSC3 1/2
#define	FOUT3_CLK_DIV_RATE_4		2		// FOUT3=OSC3 1/4
#define	OSC_SOURCE_HSCLK			0		// System clock.HSCLK.
#define	OSC_SOURCE_OSC1				1		// System clock.OSC1.
#define	OSC_SOURCE_IOSC				0		// HSCLK.IOSC.
#define	OSC_SOURCE_OSC3				1		// HSCLK.OSC3.



//macro
#define	SET_OSC3_WAIT_CYCLE(value)	OSC_CTL_OSC3WT = value
#define	SET_IOSC_WAIT_CYCLE(value)	OSC_CTL_IOSCWT = value
#define	RETURN_FOUTH_TO_P30			stopFoutH(); \
 										P3_PMUX_P30MUX = 0x00;
#define	RETURN_FOUT1_TO_P13			stopFout1(); \
 										P1_PMUX_P13MUX = 0x00;



#endif
